﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Text;
using System.Security.Cryptography;

namespace wsEncriptacion
{
    /// <summary>
    /// Service1.asmx
    /// Tutorial: Contract-First web services con Visual Studio 2008
    /// www.adictosaltrabajo.com - Ivan Garcia Puebla
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    [System.ServiceModel.ServiceBehaviorAttribute(InstanceContextMode = System.ServiceModel.InstanceContextMode.PerCall, 
        ConcurrencyMode = System.ServiceModel.ConcurrencyMode.Single)]
    public class Service1 : System.Web.Services.WebService, IcryptoServiceWSDLPortType
    {

        [WebMethod]
        public OutputEncriptar Encriptar(InputEncriptar request)
        {

            string textoAEncriptar = request.Encriptar.Original;
            string clave = request.Encriptar.Clave;
            bool usarHashing = request.Encriptar.UsarHashing;

            byte[] keyArray;
            byte[] toEncryptArray = UTF8Encoding.UTF8.GetBytes(textoAEncriptar);

            if (usarHashing)
            {
                MD5CryptoServiceProvider hashmd5 = new MD5CryptoServiceProvider();
                keyArray = hashmd5.ComputeHash(UTF8Encoding.UTF8.GetBytes(clave));
                hashmd5.Clear();
            }
            else
                keyArray = UTF8Encoding.UTF8.GetBytes(clave);

            TripleDESCryptoServiceProvider tdes = new TripleDESCryptoServiceProvider();
            tdes.Key = keyArray;
            tdes.Mode = CipherMode.ECB;
            tdes.Padding = PaddingMode.PKCS7;

            ICryptoTransform cTransform = tdes.CreateEncryptor();
            byte[] resultArray = cTransform.TransformFinalBlock(toEncryptArray, 0, toEncryptArray.Length);

            string textoEncriptado = Convert.ToBase64String(resultArray, 0, resultArray.Length);

            tdes.Clear();

            OutputEncriptar output = new OutputEncriptar();
            EncriptarResponse response = new EncriptarResponse();
            response.Resultado = textoEncriptado;
            output.EncriptarResponse = response;

            return output;
        }


        [WebMethod]
        public OutputDesencriptar Desencriptar(InputDesencriptar request)
        {

            string textoADesencriptar = request.Desencriptar.DatosDesencriptar.Encriptado;
            string clave = request.Desencriptar.DatosDesencriptar.Clave;
            bool usarHashing = request.Desencriptar.DatosDesencriptar.UsarHashing;

            byte[] keyArray;
            byte[] toEncryptArray = Convert.FromBase64String(textoADesencriptar);

            if (usarHashing)
            {
                MD5CryptoServiceProvider hashmd5 = new MD5CryptoServiceProvider();
                keyArray = hashmd5.ComputeHash(UTF8Encoding.UTF8.GetBytes(clave));
                hashmd5.Clear();
            }
            else
                keyArray = UTF8Encoding.UTF8.GetBytes(clave);

            TripleDESCryptoServiceProvider tdes = new TripleDESCryptoServiceProvider();
            tdes.Key = keyArray;
            tdes.Mode = CipherMode.ECB;
            tdes.Padding = PaddingMode.PKCS7;

            ICryptoTransform cTransform = tdes.CreateDecryptor();
            byte[] resultArray = cTransform.TransformFinalBlock(toEncryptArray, 0, toEncryptArray.Length);

            string textoDesencriptado = UTF8Encoding.UTF8.GetString(resultArray);
            
            tdes.Clear();

            OutputDesencriptar output = new OutputDesencriptar();
            DesencriptarResponse response = new DesencriptarResponse();
            response.Resultado = textoDesencriptado;
            output.DesencriptarResponse = response;

            return output;
        }
    }
}
